# Toward Robust Novelty Detection Under Style Shifts

Initial code of our work for submission to ICLR 2025.

## 1. Environments

Create a new conda environment and install required packages.

```
conda create -n my_env python=3.8.12
conda activate my_env
pip install -r requirements.txt
```

## 2. Prepare Datasets

For each of the implemented datasets, provide the relative dataloader(s) with the path to the data. 
All data we used in this work are publicly available and are properly cited with their licenses mentioned Appendix F of our paper.


## 3. Run Experiments

For each dataset, run the corresponding file using 

```
!python {dataset_name}.py
```

The testing procedure, i.e., evaluation on both the main and shifted datasets is implicitly done for each dataset.
Our model is implemented only on the backbones Resnet18 and Wide_Res_50_2. Choose the backbone accordingly. For each file,
we have included several flags in the main function, which can be optionally used, but running without the flags should reproduce
the results reported.
